/***************************************************************************/
/*                                                                         */
/*   comet_posi.c :uÓVwvLڂ̕@ɂäʒǔvZ            */
/*      Ver. 1.0    1999/06/29          By   takesako@mrj.biglobe.ne.jp    */
/*                                           (c)1999 Shinobu Takesako      */
/***************************************************************************/

#include <stdio.h>
#include <math.h>

#include "astro.h"

void Comet_Position(double jd , Position *Comet, Parameter Comet_Para)
{

	double T,Epo,Qq,Mu,Ax,Ec,Omg,Somg,Inc,obl,Ma,Ex,Exa,Equ,jd_Equ;
	double cosSOMG,sinSOMG,cosOMG,sinOMG,cosINC,sinINC,cosOBL,sinOBL;
	double Px,Py,Pz,Qx,Qy,Qz,sx,sy,sz,sr;
	double Axx,Ayy,Azz,Bx,By,Bz,xx,yy,zz,rr,cx,cy,cz,dd;
	double Day,Ra,Dec,N,H,br,lam,bet;
	double S0,S,F;
	double Elong, Phase;

    T   = Comet_Para.T;
    Epo = Comet_Para.Epo;
	Qq  = Comet_Para.Qq;
	Mu  = Comet_Para.Mu;
	Ax  = Comet_Para.Ax;
	Ec  = Comet_Para.Ec;
	Omg = Comet_Para.Omg*pai;
	Somg= Comet_Para.Somg*pai;
	Inc = Comet_Para.Inc*pai;
	Equ = Comet_Para.Equ;
	H= Comet_Para.G0;
	N= Comet_Para.Ne;

	jd_Equ=JD( Equ,1,1,0,0,0);
	obl = Obl(jd_Equ)*pai;

	cosSOMG = cos(Somg);
	sinSOMG = sin(Somg);
	cosOMG  = cos(Omg);
	sinOMG  = sin(Omg);
	cosINC  = cos(Inc);
	sinINC  = sin(Inc);
	cosOBL  = cos(obl);
	sinOBL  = sin(obl);
	
	Px = cosSOMG * cosOMG - sinSOMG * sinOMG * cosINC;
	Py = (cosSOMG * sinOMG + sinSOMG * cosOMG * cosINC) * cosOBL - sinSOMG * sinINC * sinOBL;
	Pz = (cosSOMG * sinOMG + sinSOMG * cosOMG * cosINC) * sinOBL + sinSOMG * sinINC * cosOBL;

	Qx = -sinSOMG * cosOMG - cosSOMG * sinOMG * cosINC;
	Qy = (-sinSOMG * sinOMG + cosSOMG * cosOMG * cosINC) * cosOBL - cosSOMG * sinINC * sinOBL;
	Qz = (-sinSOMG * sinOMG + cosSOMG * cosOMG * cosINC) * sinOBL + cosSOMG * sinINC * cosOBL;
	

	if ((int)Ec==1){
	/* O̜a*/
	Day = jd - T;
	Ma = Day /(Qq*sqrt(Qq));
	N= Ma/82.2117;
	S0 = N;
	while(1){
		S=(N+2.0/3.0*S0*S0*S0)/(1+S0*S0);
		if(fabs(S-S0)<1e-9) break;
		S0=S;
		}
/*printf("S=%12.7f \n",S);*/
	F=1-S*S;
	xx = Qq*(Px*F+2.0*Qx*S); 
	yy = Qq*(Py*F+2.0*Qy*S);  
	zz = Qq*(Pz*F+2.0*Qz*S);  
	rr = sqrt(xx*xx + yy*yy + zz*zz);
/*printf("xx= %12.5f yy= %12.5f zz= %12.5f rr= %12.5f\n",xx,yy,zz,rr);*/

		}

	else {
	/* a*/
	Axx = Ax * Px;
	Ayy = Ax * Py;
	Azz = Ax * Pz;

/*printf("Axx= %12.5f Ayy= %12.5f Azz= %12.5f\n",Axx,Ayy,Azz);*/
	Bx = Ax * sqrt (1.0 - Ec * Ec) * Qx;
	By = Ax * sqrt (1.0 - Ec * Ec) * Qy;
	Bz = Ax * sqrt (1.0 - Ec * Ec) * Qz;

/*printf("Bx= %12.5f By= %12.5f Bz= %12.5f\n",Bx,By,Bz);*/
	
	Day = jd - T;
	Mu = 0.9856076 /(Ax * sqrt (Ax));
	Ma = Mu * Day;

    Keplar( Ma, Ec, &Exa);
	Ex = Exa*pai;
/*printf("Ma= %12.5f Ec= %12.5f Ex= %12.5f\n",Ma,Ec,Ex);*/

	xx = Axx * (cos(Ex)-Ec) + Bx * sin (Ex); 
	yy = Ayy * (cos(Ex)-Ec) + By * sin (Ex); 
	zz = Azz * (cos(Ex)-Ec) + Bz * sin (Ex); 
	rr = sqrt(xx*xx + yy*yy + zz*zz);
/*printf("xx= %12.5f yy= %12.5f zz= %12.5f rr= %12.5f\n",xx,yy,zz,rr);*/

	}

	Solar_Geo (jd,Equ,&sx,&sy,&sz);
	sr=sqrt(sx*sx+sy*sy+sz*sz);
/*printf("sx= %12.5f sy= %12.5f sz= %12.5f sr= %12.5f\n",sx,sy,sz,sr);*/

	cx=sx+xx;
	cy=sy+yy;
	cz=sz+zz;
	dd=sqrt(cx*cx+cy*cy+cz*cz);
/*printf("cx= %12.5f cy= %12.5f cz= %12.5f dd= %12.5f\n",cx,cy,cz,dd);*/

	Ra = atan2(cy,cx)/pai;
	if (Ra<0) Ra= Ra+360.0;
	Dec = asin(cz/dd)/pai;


	Elong= acos((sr*sr+dd*dd-rr*rr)/(2.0*sr*dd))/pai;
	if(Elong<0) Elong=Elong+180.0;
	Phase= acos((rr*rr+dd*dd-sr*sr)/(2.0*rr*dd))/pai;
	if(Phase<0) Phase=Phase+180.0;

	br = H + 5.0*log10(dd) + 2.5 * N * log10(rr);

	Comet->ra  = Ra;
	Comet->dec = Dec;
	Comet->d   = dd;
	Comet->x   = cx;
	Comet->y   = cy;
	Comet->z   = cz;
	Comet->br  = br;
	Comet->elong = Elong;
	Comet->phase = Phase;
	Comet->r     = rr;

	RaToLam( jd, Ra,Dec, &lam, &bet);
	Comet->lam = lam;
	Comet->bet = bet;

}


void Keplar(double Ma, double Ec, double *Exa)
{
	double Ss,Delta,Ex;

	Ma=Ma*pai;
	Ss=Ec;
	Ex=Ma;
	while(fabs(Ss)>1e-9){
		Ss=Ex-Ec*sin(Ex)-Ma;
		Delta=Ss/(1-Ec*cos(Ex));
		Ex=Ex-Delta;
		}

	*Exa=Ex/pai;

}

