/***************************************************************************/
/*                                                                         */
/*   moon_posi.c      :  uÓVwvLڂ̕@ɂ錎̈ʒǔvZ        */
/*      Ver. 1.1    1999/07/02          By   takesako@mrj.biglobe.ne.jp    */
/*                                           (c) Shinobu Takesako          */
/***************************************************************************/
/*    1999/07/01   mrrvZ̃oOCipai|ĂȂBj            */
/***************************************************************************/

#include <stdio.h>
#include <math.h>

#include "astro.h"

void Moon_Position  (double jd , Position *Moon, int option, double latitude, double longitude)
{

/*
option:              0 :@␳O
                     1 :@␳̒lԂ
latitude, longitude: ␳̏ꍇ̊ϑ_ʒu
*/

	double j,lst,lat;
	double mml,mpnl,mec,max,momg,minc,mma,mex,mta;
	double muu,mmm,mlam,mlam1,mbet,mtb,mrr,PI,L,B,mga;
	double mtb1,mss,obl;
	double aa,bb,cc,dd,ee,hh,a0,b0,c0,d0,e0,h0,st;
	double mtv,mde,mtt,a,b ;
	double Ra, Dec, Phase,md;

    j=J_1800(jd);

	mml = 335.723436 + 481267.887361*j + 3.38888e-3*j*j + 1.83333e-6*j*j*j;
	mml = Compact (mml,360);
	mpnl = 225.397325 + 4069.053805*j - 1.02869e-2*j*j -1.22222e-5*j*j*j;
	mpnl = Compact (mpnl , 360);
	mec = 0.05490897;
	max = 60.2682;
	momg = 33.272936 - 1934.144694*j + 2.08028e-3*j*j + 2.08333e-6*j*j*j;
	momg = Compact (momg , 360);
	minc = 5.1444433;

	aa = 1.2949 + 413335.4078*j - 7.2201e-3*j*j - 0.72305e-5*j*j*j;
	bb = 111.6209 + 890534.2514*j + 6.9838e-3*j*j +0.69778e-5*j*j*j;
	cc = 180.40885 + 35999.0552*j - 0.0001988*j*j;
	dd = 0.88605 + 377336.3526*j - 7.0213e-3*j*j - 0.72305e-5*j*j*j;
	ee = 111.21205 + 854535.1962*j + 7.1826e-3*j*j + 0.69778e-5*j*j*j;
	hh = 169.1706 + 407332.2103*j + 5.3354e-3*j*j + 0.53292e-5*j*j*j;

	a0 = 1.2408 * sin (aa * pai);
	b0 = 0.5958 * sin (bb * pai);
	c0 = 0.1828 * sin (cc * pai);
	d0 = 0.0550 * sin (dd * pai);
	e0 = 0.0431 * sin (ee * pai);
	st = a0 + b0 + c0 + d0 + e0;
	h0 = 0.1453 * sin (hh * pai);

	mml = mml + st;

	mma = mml - mpnl;
	mma = Compact ( mma , 360);

	mma = mma * pai ;

	mex = mma;
	mtv = mex - mec*sin(mex) - mma;

	while (fabs(mtv) > 1e-8){
		mde = mtv / (1 - mec * cos (mex));
		mex = mex - mde;
		mtv = mex - mec * sin (mex) - mma;
		};

	mtt = sqrt((1 + mec)/(1 - mec)) * tan ( mex /2);

	mta = 2 * atan (mtt) /pai;

	if (mta < 0){
		mta = mta + 360;
		};
	muu = mta + mpnl - momg;
	if(muu > 360){
	      muu = muu - 360;
	      };
	if(muu<0){
	      muu = muu + 360;
	      };

	mmm = atan (cos (minc*pai) * tan (muu*pai))/pai;
	if ( muu > 90 && muu < 270 ){
		mmm = mmm + 180;
		};
	if ( muu >= 270 ){
		mmm = mmm + 360;
		};


	mlam = mmm + momg;
	mlam = Compact ( mlam ,360);
	mbet = tan (minc * pai)* sin (mmm * pai);

	mtb = atan ( mbet )/pai;
	mtb = mtb + h0;


	LamToRa( jd, mlam, mtb, &Ra, &Dec);

	mrr = max *(1-mec*mec)/ ( 1 + mec * cos (mta*pai));  /* 1999/07/01 oOC*/
	mss = asin(0.2725 /(mrr))/pai; 
	
	Moon->lam = mlam;
	Moon->bet = mtb;
	Moon->ra  = Ra;
	Moon->dec = Dec;
	Moon->ss  = mss;
	Moon->br  = 0.0;

    Sun_Position (jd, &Sun );

	md = (mlam-Sun.lam);
	if (md <0)   md = md + 360;
	if (md >360) md = md - 360;
	md = md/360.0*29.53;

	Phase = acos(cos((mlam-Sun.lam)*pai)*cos(mtb*pai));
	Moon->br=md;

	if (option==0) return;
	
	PI = asin(1/ mrr )/pai;
	PI = PI/0.99;

    lst = LST(jd,longitude)*15.0;
	lat = latitude;
	obl = Obl(jd);

	a = cos (obl * pai) * cos (lat * pai) *sin (lst *pai) + sin (obl * pai) * sin (lat * pai);
	b = cos (lat * pai) * cos (lst * pai);
	L = atan2 (a,b)/pai;

	B =asin( - sin (obl *pai) * cos ( lat * pai) * sin (lst * pai) + cos (obl *pai)* sin ( lat *pai))/pai;

	mlam1 = asin(- sin(PI * pai)* cos (B * pai)* sin (( L - mlam)*pai)/cos( mtb* pai))/pai;
	mga = atan (tan ( B * pai)/ cos((L -mlam)*pai));
	mtb1 =asin(- ( sin (PI * pai) * sin (B* pai) * sin ( mga - mtb*pai))/ sin (mga))/pai;

	mlam = mlam + mlam1;
	mbet = mtb + mtb1;
	mss = asin(0.2725 /(mrr*0.99))/pai;

	Moon->lam = mlam;
	Moon->bet = mbet;
	Moon->ss  = mss;
	LamToRa( jd, mlam, mbet, &Ra, &Dec);/* 1999/06/17 am 11:00 */
	Moon->ra  = Ra;
	Moon->dec = Dec;
	
	md = (mlam-Sun.lam);
	if (md <0)   md = md + 360;
	if (md >360) md = md - 360;
	md = md/360.0*29.53;

	Phase = acos(cos((mlam-Sun.lam)*pai)*cos(mbet*pai));
	Moon->br=md;

}

