/***************************************************************************/
/*                                                                         */
/*   planet_posi.c :uÓVwvLڂ̕@ɂf̈ʒǔvZ           */
/*      Ver. 1.1    1999/06/29          By   takesako@mrj.biglobe.ne.jp    */
/*                                           (c)19999 Shinobu Takesako     */
/***************************************************************************/
/*    1999/06/29  zʒuvZsun_posi.cɕ                           */
/***************************************************************************/

#include <stdio.h>
#include <math.h>

#include "astro.h"
#include "Tafel_VIII.h"

void Planet_Position (int Planet_number, double jd, Position *Planet)
{
	double c;
	double ml,pnl,ec,ax,omg,inc,ma,mpg,ta;
	double uu,cc,ll,tb,rr,xx,yy,zz;
	double ex,ey,ez,dd,lam,bet, elo,hl,ii,br,tt,sd;
	int Pln,Eta1,Eta0,Zeta1,Zeta0;
	double T_year, L7_a,L7,L8,Ps7,Ps8,Ph7,Ph8,Ax7,Ax8,Eta,Zeta,Ph, Zeta_diff, Eta_diff;
	double Ra, Dec;
	
	static double Ax[6][4]={
	{  0.38709840,  0.0,  0.0, 0.0},
	{  0.72333015,  0.0,  0.0, 0.0},
	{  0.0       ,  0.0,  0.0, 0.0},
	{  1.52367810,  0.0,  0.0, 0.0},
	{  5.20280500,  0.0,  0.0, 0.0},
	{  9.55474700,  0.0,  0.0, 0.0},
	};
	static double Ec[6][4]={
	{  0.20561494,  0.02030e-3  , -0.04e-6  ,  0.0    },
	{  0.00681636, -0.5384e-4   ,  0.126e-6 ,  0.0    },
	{  0.0       ,  0.0         ,  0.0      ,  0.0    },
	{  0.09330880,  0.095284e-3 , -0.122e-6 ,  0.0    },
	{  0.0483348 ,  0.164180e-3 , -0.4676e-6, -1.7e-9 },
	{  0.05589231, -0.34550e-3  , -0.728e-6 ,  0.74e-9},
	};
	static double Ml[6][4]={
	{  182.27175 , 149474.07244 , 2.01944e-3 ,  0.0        },
	{  344.36936 ,  58519.2126  , 9.8055e-4  ,  0.0        },
	{    0.0     ,      0.0     , 0.0        ,  0.0        },
	{  294.26478 ,  19141.69625 , 3.15028e-4 ,  0.0        },
	{  238.132386,   3036.301986, 3.34683e-4 , -1.64889e-6 },
	{  266.597875,   1223.50988 , 3.24542e-4 , -5.83333e-7 },
	};
	static double Pnl[6][4]={
	{    75.89717 , 1.553469 ,  3.08639e-4 ,  0.0       },
	{   130.14057 , 1.37230  , -1.6472e-3  ,  0.0       },
	{     0.0     , 0.0      ,  0.0        ,  0.0       },
	{   334.21833 , 1.840394 ,  3.35917e-4 ,  0.0       },
	{    12.720972, 1.6099617,  1.05627e-3 , -3.4333e-6 },
	{    91.09821 , 1.958416 ,  8.26361e-4 ,  4.61111e-6},
	};
	static double Omg[6][4]={
	{    47.144736, 1.18476  ,  2.23194e-4  ,  0.0        },
	{    75.7881  , 0.91403  ,  4.189e-4    ,  0.0        },
	{     0.0     , 0.0      ,  0.0         ,  0.0        },
	{    48.78670 , 0.776944 , -6.02778e-4  ,  0.0        },
	{    99.443414, 1.01053  , +3.52222e-4  , -8.51111e-6 },
	{   112.790414, 0.873195 , -1.521810e-4 , -5.30555e-6 },
	};
	static double Inc[6][4]={
	{  7.003014  ,  1.73833e-3, -1.55555e-5,  0.0 },
	{  3.3936    ,  1.2522e-3 , -4.333e-6  ,  0.0 },
	{  0.0       ,  0.0       ,  0.0       ,  0.0 },
	{  1.85030   , -6.49028e-4,  2.65e-5   ,  0.0 },
	{  1.308736  , -5.69611e-3,  3.88889e-6,  0.0 },
	{  2.4925194 , -3.91889e-3, -1.54889e-5, 4.44444e-8},
	};

	Pln=Planet_number-1;
    c=C_1900(jd);

	if(Planet_number==5){
		T_year = (c +19.0)/10.0; /* year/1000 */
		L7_a  = 0.42 - 0.075*T_year + 0.015*T_year*T_year - 0.003*T_year*T_year*T_year;
		L7    = L7_a*sin((T_year-0.62)*360/0.925*pai);
		Ps7   = 0.02*sin((T_year+0.1)*360/0.925*pai);
		Ph7   = 0.03*sin((T_year+0.36)*360/0.925*pai);
		Eta   = 86.1+0.033459*(jd-1721057);
		Eta   = Compact (Eta,360);
		Zeta  = 89.1+0.049630*(jd-1721057);
		Zeta  = Compact (Zeta,360);
		Eta0  = (int)(Eta/10.0);
		Zeta0 = (int)(Zeta/10.0);
		Eta1  = Eta0+1;
		Zeta1 = Zeta0+1;
		Zeta_diff=Zeta-(double)Zeta0*10.0;
		Eta_diff = Eta-(double)Eta0*10.0;
		L8  = Table_Value(Jup_L8 [Zeta0][Eta0], Jup_L8 [Zeta1][Eta0], Jup_L8 [Zeta0][Eta1], Jup_L8 [Zeta1][Eta1], Zeta_diff, Eta_diff)/100.0;
		Ps8 = Table_Value(Jup_Ps8[Zeta0][Eta0], Jup_Ps8[Zeta1][Eta0], Jup_Ps8[Zeta0][Eta1], Jup_Ps8[Zeta1][Eta1], Zeta_diff, Eta_diff)/100.0;
		Ph8 = Table_Value(Jup_Ph8[Zeta0][Eta0], Jup_Ph8[Zeta1][Eta0], Jup_Ph8[Zeta0][Eta1], Jup_Ph8[Zeta1][Eta1], Zeta_diff, Eta_diff)/100.0;
		Ph = 2.58 + 0.1 * T_year;

		
		L7 =Digit2(L7);
		L8 =Digit2(L8);
		Ps7=Digit2(Ps7);
		Ps8=Digit2(Ps8);
		Ph7=Digit2(Ph7);
		Ph8=Digit2(Ph8);
		
		
/*		printf("\nT_year= %.6f L7_a= %.6f L7= %.6f L8= %.6f\n Ps7= %.6f Ps8= %.6f Ph7= %.6fPh8= %.6f \n Eta= %.6fZeta= %.6f\n",T_year, L7_a,L7,L8,Ps7,Ps8,Ph7,Ph8,Eta,Zeta);
*/	
	
	};
	
	if(Planet_number==6){
		T_year = (c +19.0)/10.0; /* year/1000 */
		L7_a =  0.88  - 0.0633*T_year + 0.03*T_year*T_year - 0.0006*T_year*T_year*T_year;
		L7   = -0.5   + L7_a*sin((T_year-0.145)*360/0.95*pai);
		Ps7  = -0.50  + (0.10 -0.005 *T_year)*sin((T_year-0.54)*360/0.95*pai);
		Ph7  = -0.50  + (0.10 -0.005 *T_year)*sin((T_year-0.32)*360/0.95*pai);
		Ax7  = -0.050 + (0.004-0.0005*T_year)*sin((T_year-0.35)*360/0.95*pai);
		Eta  = 86.1+0.033459*(jd-1721057);
		Eta  = Compact (Eta,360);
		Zeta = 89.1+0.049630*(jd-1721057);
		Zeta = Compact (Zeta,360);
		Eta0 = (int)(Eta/10.0);
		Zeta0 = (int)(Zeta/10.0);
		Eta1 =Eta0+1;
		Zeta1=Zeta0+1;
		Zeta_diff=Zeta-(double)Zeta0*10.0;
		Eta_diff= Eta-(double)Eta0*10.0;
		L8  = Table_Value(Sat_L8 [Zeta0][Eta0], Sat_L8 [Zeta1][Eta0], Sat_L8 [Zeta0][Eta1], Sat_L8 [Zeta1][Eta1], Zeta_diff, Eta_diff)/100.0;
		Ps8 = Table_Value(Sat_Ps8[Zeta0][Eta0], Sat_Ps8[Zeta1][Eta0], Sat_Ps8[Zeta0][Eta1], Sat_Ps8[Zeta1][Eta1], Zeta_diff, Eta_diff)/100.0;
		Ph8 = Table_Value(Sat_Ph8[Zeta0][Eta0], Sat_Ph8[Zeta1][Eta0], Sat_Ph8[Zeta0][Eta1], Sat_Ph8[Zeta1][Eta1], Zeta_diff, Eta_diff)/100.0;
		Ax8 = Table_Value(Sat_Ax8[Zeta0][Eta0], Sat_Ax8[Zeta1][Eta0], Sat_Ax8[Zeta0][Eta1], Sat_Ax8[Zeta1][Eta1], Zeta_diff, Eta_diff)/1000.0;
		Ph = 3.56 -0.175 * T_year - 0.005*T_year*T_year ;

		L7 =Digit2(L7);
		L8 =Digit2(L8);
		Ps7=Digit2(Ps7);
		Ps8=Digit2(Ps8);
		Ph7=Digit2(Ph7);
		Ph8=Digit2(Ph8);
		Ax7=Digit3(Ax7);
		Ax8=Digit3(Ax8);

/*	printf("\nT_year= %.6f L7_a= %.6f L7= %.6f L8= %.6f\n Ps7= %.6f Ps8= %.6f Ph7= %.6f Ph8= %.6f\n Ax7= %.6f Ax8= %.6f Eta= %.6f,Zeta= %.6f\n",T_year, L7_a,L7,L8,Ps7,Ps8,Ph7,Ph8,Ax7,Ax8,Eta,Zeta);
*/	
	
	};


	ml = Ml[Pln][0] + Ml[Pln][1]*c + Ml[Pln][2]*c*c+Ml[Pln][3]*c*c*c;
	ml = Compact (ml,360);
/*printf(" ml = %.6f", ml);*/
	if(Planet_number==5 || Planet_number==6 ){ 
		ml=ml +L7+L8;	
	};

	pnl = Pnl[Pln][0] + Pnl[Pln][1]*c + Pnl[Pln][2]*c*c+Pnl[Pln][3]*c*c*c;
	pnl = Compact (pnl , 360);
/*printf(" pnl= %.6f", pnl);*/
	if(Planet_number==5 || Planet_number==6 ){ 
		pnl=pnl +(Ps7+Ps8)/sin(Ph*pai);	
	};

	ec = Ec[Pln][0] + Ec[Pln][1]*c + Ec[Pln][2]*c*c+Ec[Pln][3]*c*c*c;
/*printf(" ec = %.6f", ec);*/

	if(Planet_number==5 || Planet_number==6 ){ 
		ec=sin((Ph+Ph7+Ph8)*pai);	
	};

	ax = Ax[Pln][0];
	if(Planet_number==6){
		ax = ax + Ax7 + Ax8;
		};

	omg = Omg[Pln][0] + Omg[Pln][1]*c + Omg[Pln][2]*c*c+Omg[Pln][3]*c*c*c;
	omg = Compact (omg , 360);

	inc = Inc[Pln][0] + Inc[Pln][1]*c + Inc[Pln][2]*c*c+Inc[Pln][3]*c*c*c;

	ma = ml - pnl;
	if(ma<0){
	      ma = ma + 360;
	      };

	mpg = (2*ec - ec*ec*ec/4.0)*sin(ma*pai) + 5.0/4.0*ec*ec*sin(2.*ma*pai) + 13.0/12.0*ec*ec*ec*sin(3.*ma*pai);
	mpg =  mpg/pai;
	
	ta = ma+mpg;

	uu = ta + pnl - omg;
	if(uu > 360){
	      uu = uu - 360;
	      };
	if(uu<0){
	      uu = uu + 360;
	      };

	cc = atan (cos (inc*pai) * tan (uu*pai))/pai;
	if ( uu > 90 && uu < 270 ){
		cc = cc + 180;
		};
	if ( uu >= 270 ){
		cc = cc + 360;
		};

	ll = cc + omg;
	if (ll >360) {
		ll = ll - 360 ;
		};

	tb = atan (tan (inc*pai) * sin(cc*pai))/pai;

	rr = ax * (1- ec*ec) / (1+ ec* cos(ta*pai));

	xx = rr * (cos(uu*pai)*cos(omg*pai) - sin(uu*pai)*sin(omg*pai)*cos(inc*pai));

	yy = rr * (cos(uu*pai)*sin(omg*pai) + sin(uu*pai)*cos(omg*pai)*cos(inc*pai));

	zz = rr *  sin(uu*pai)*sin(inc*pai);

    Sun_Position (jd, &Sun );
 
	ex=Sun.x+xx;
	ey=Sun.y+yy;
	ez=Sun.z+zz;
	dd=sqrt(ex*ex+ey*ey+ez*ez);

	lam = atan2(ey,ex)/pai;
	if (lam<0) lam= lam+360.0;
	bet = asin(ez/dd)/pai;


/*	elo=acos(cos((lam-Sun.lam)*pai)*cos(bet*pai))/pai;*/
	elo=lam-Sun.lam;
	hl = ll - Sun.lam;
	if(hl<0) hl=hl+360.0;
	
	tt=sqrt(rr*rr+Sun.r*Sun.r+2*rr*Sun.r*cos(hl*pai));
	ii=acos((rr*rr+tt*tt-Sun.r*Sun.r)/(2*rr*tt))/pai;

	if(Planet_number==1 )	{br = +1.16 + 5.0*log10(rr*tt) + 0.02823*fabs(ii-50.0)+0.0001023*(ii-50)*(ii-50);
							sd=3.36/3600.0/dd;}
	if(Planet_number==2 )	{br = -4.00 + 5.0*log10(rr*tt) + 0.01322*ii +0.0000004247*ii*ii*ii;
							sd=8.34/3600.0/dd;}
	if(Planet_number==4 )	{br = -1.30 + 5.0*log10(rr*tt) + 0.01486*ii;
							sd=4.64/3600.0/dd;}
	if(Planet_number==5 )	{br = -8.93 + 5.0*log10(rr*tt);
							sd=98.44/3600.0/dd;}
	if(Planet_number==6 )	{br = -8.68 + 5.0*log10(rr*tt) - 1.1*fabs(sin(ll+38.0-T_year*1000));
							sd=82.73/3600.0/dd;}
	Planet->lam = lam;
	Planet->bet = bet;
	Planet->r   = dd;
	Planet->x   = xx;
	Planet->y   = yy;
	Planet->z   = zz;
	Planet->br  = br;
	Planet->ss  = sd;

	LamToRa( jd, lam, bet, &Ra, &Dec);
	Planet->ra  = Ra;
	Planet->dec = Dec;

	
/*	printf("\nml= %.6f pnl= %.6f ec= %.6f ax= %.6f\n omg= %.6f inc= %.6f ma= %.6f mpg= %.6f\n ta= %.6f",ml,pnl,ec,ax,omg,inc,ma,mpg,ta);
	printf(" uu= %.6f cc= %.6f ll= %.6f\n tb= %.6f rr= %.6f xx= %.6f yy= %.6f\n zz= %.6f",uu,cc,ll,tb,rr,xx,yy,zz);
	printf(" ex= %.6f ey= %.6f ez= %.6f\n dd= %.6f lam= %.6f bet= %.6f elo= %.6f\n hl= %.6f ii= %.6f br= %.6f tt= %.6f\n sd= %.6f\n\n",ex,ey,ez,dd,lam,bet, elo,hl,ii,br,tt,sd);
*/
  }




